Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections
Interface MapIterator

All Superinterfaces:
  java.util.Iterator

All Known Subinterfaces:
  OrderedMapIterator

All Known Implementing Classes:
  AbstractDualBidiMap.BidiMapIterator, AbstractHashedMap.HashMapIterator, AbstractLinkedMap.LinkMapIterator, AbstractMapIteratorDecorator, AbstractOrderedMapIteratorDecorator, DualTreeBidiMap.BidiOrderedMapIterator, EmptyMapIterator, EmptyOrderedMapIterator, EntrySetMapIterator, UnmodifiableMapIterator, UnmodifiableOrderedMapIterator

    public interface MapIterator

extends java.util.Iterator

Defines an iterator that operates over a `Map`.

This iterator is a special version designed for maps. It can be more efficient to use this rather than an entry set iterator where the option is available, and it is certainly more convenient.

A map that provides this interface may not hold the data internally using Map Entry objects, thus this interface can avoid lots of object creation.

In use, this iterator iterates through the keys in the map. After each call to `next()`, the `getValue()` method provides direct access to the value. The value can also be set using `setValue()`.

     MapIterator it = map.mapIterator();
     while (it.hasNext()) {
       Object key = it.next();
       Object value = it.getValue();
       it.setValue(newValue);
     }

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne

Method Summary
`java.lang.Object` | `getKey()` Gets the current key, which is the key returned by the last call to `next()`.
`java.lang.Object` | `getValue()` Gets the current value, which is the value associated with the last key returned by `next()`.
`boolean` | `hasNext()` Checks to see if there are more entries still to be iterated.
`java.lang.Object` | `next()` Gets the next key from the `Map`.
`void` | `remove()` Removes the last returned key from the underlying `Map` (optional operation).
`java.lang.Object` | `setValue(java.lang.Object value)` Sets the value associated with the current key (optional operation).

Method Detail

### hasNext

    boolean hasNext()

  Checks to see if there are more entries still to be iterated.

  Specified by:
    `hasNext` in interface `java.util.Iterator`
  Returns:
    `true` if the iterator has more elements

### next

    java.lang.Object next()

  Gets the next key from the `Map`.

  Specified by:
    `next` in interface `java.util.Iterator`
  Returns:
    the next key in the iteration
  Throws:
    `java.util.NoSuchElementException` - if the iteration is finished

### getKey

    java.lang.Object getKey()

  Gets the current key, which is the key returned by the last call to `next()`.

  Returns:
    the current key
  Throws:
    `java.lang.IllegalStateException` - if `next()` has not yet been called

### getValue

    java.lang.Object getValue()

  Gets the current value, which is the value associated with the last key returned by `next()`.

  Returns:
    the current value
  Throws:
    `java.lang.IllegalStateException` - if `next()` has not yet been called

### remove

    void remove()

  Removes the last returned key from the underlying `Map` (optional operation).

  This method can be called once per call to `next()`.

  Specified by:
    `remove` in interface `java.util.Iterator`
  Throws:
    `java.lang.UnsupportedOperationException` - if remove is not supported by the map
    `java.lang.IllegalStateException` - if `next()` has not yet been called
    `java.lang.IllegalStateException` - if `remove()` has already been called since the last call to `next()`

### setValue

    java.lang.Object setValue(java.lang.Object value)

  Sets the value associated with the current key (optional operation).

  Parameters:
    `value` - the new value
  Returns:
    the previous value
  Throws:
    `java.lang.UnsupportedOperationException` - if setValue is not supported by the map
    `java.lang.IllegalStateException` - if `next()` has not yet been called
    `java.lang.IllegalStateException` - if `remove()` has been called since the last call to `next()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.